package com.jiuqi.syntax;

import com.jiuqi.util.ChineseCurrencyFormat;
import com.jiuqi.util.ChineseNumberFormat;
import com.jiuqi.util.IDCard;
import com.jiuqi.util.StringTokenEnumeration;
import java.text.NumberFormat;

/* loaded from: com_jiuqi_syntax.jar:com/jiuqi/syntax/CommonFunctionListener.class */
public final class CommonFunctionListener extends CustomFunctionListener {
    public CommonFunctionListener() {
        Function func = this.functions.addFunc("ABS", "绝对值", "返回给定数值的绝对值", 2);
        func.params.addParam("value", "数值", 2);
        Function func2 = this.functions.addFunc("INT", "取整", "将数值向下取整为最接近的整数", 2);
        func2.params.addParam("value", "数值", 2);
        Function func3 = this.functions.addFunc("ROUND", "四舍五入取整", "按指定的位数对数值进行四舍五入", 2);
        func3.params.addParam("value", "数值", 2);
        func3.params.addParam("dec", "数位", 2, true);
        Function func4 = this.functions.addFunc("MOD", "求模", "返回两数相除的余数", 2);
        func4.params.addParam("value", "数值", 2);
        func4.params.addParam("mvalue", "模数", 2);
        Function func5 = this.functions.addFunc("POWER", "求幂", "返回某数的乘幂", 2);
        func5.params.addParam("value", "数值", 2);
        func5.params.addParam("exponent", "幂数", 2);
        Function func6 = this.functions.addFunc("TAN", "正切值", "返回给定数值的正切值", 2);
        func6.params.addParam("value", "数值", 2);
        Function func7 = this.functions.addFunc("ATAN", "反正切值", "返回给定数值的反正切值", 2);
        func7.params.addParam("value", "数值", 2);
        Function func8 = this.functions.addFunc("LN", "自然对数", "返回给定数值的自然对数", 2);
        func8.params.addParam("value", "数值", 2);
        Function func9 = this.functions.addFunc("LOG10", "10为底的对数", "返回给定数值的10为底的对数", 2);
        func9.params.addParam("value", "数值", 2);
        Function func10 = this.functions.addFunc("LOG", "对数", "返回给定数值的对数", 2);
        func10.params.addParam("value", "数值", 2);
        Function func11 = this.functions.addFunc("L$", "左串", "从一个文本字符串的第一个字符开始返回指定个数的字符", 3);
        func11.params.addParam("text", "字符值", 3);
        func11.params.addParam("length", "长度", 1);
        Function func12 = this.functions.addFunc("M$", "中串", "从文本字符串中指定的起始位置起返回指定长度的字符", 3);
        func12.params.addParam("text", "字符值", 3);
        func12.params.addParam("start", "开始位置", 1);
        func12.params.addParam("length", "长度", 1);
        Function func13 = this.functions.addFunc("R$", "右串", "从一个文本字符串的最后一个字符开始返回指定个数的字符", 3);
        func13.params.addParam("text", "字符值", 3);
        func13.params.addParam("length", "长度", 1);
        Function func14 = this.functions.addFunc("LEN", "长度", "返回文本字符串中的字符个数", 1);
        func14.params.addParam("text", "字符值", 3);
        Function func15 = this.functions.addFunc("VAL", "求值", "将一个文本字符串转换成数值", 2);
        func15.params.addParam("text", "字符值", 3);
        Function func16 = this.functions.addFunc("POS", "在字符串中", "返回一个字符串在另一个字符串中出现的起始位置", 1);
        func16.params.addParam("substring", "子字符串", 3);
        func16.params.addParam("totalstring", "完整字符值", 3);
        Function func17 = this.functions.addFunc("ISDIGIT", "是数字", "判断一个字符串是否仅包含数字", 5);
        func17.params.addParam("text", "字符值", 3);
        Function func18 = this.functions.addFunc("STR", "字符", "将数值转换成文本", 3);
        func18.params.addParam("value", "数值", 2);
        func18.params.addParam("dec", "小数位", 1, true);
        func18.params.addParam("thousand", "千分位", 5, true);
        Function func19 = this.functions.addFunc("UPPERCASE", "字符转大写", "将给定字符值中的所有小写字母转为大写字母", 3);
        func19.params.addParam("value", "字符值", 3);
        Function func20 = this.functions.addFunc("LOWERCASE", "字符转小写", "将给定字符值中的所有大写字母转为小写字母", 3);
        func20.params.addParam("value", "字符值", 3);
        Function func21 = this.functions.addFunc("MONEYSTR", "中文金额", "将金额转换成金额中文文本", 3);
        func21.params.addParam("money", "金额数值", 2);
        func21.params.addParam("prefix", "输出前缀", 3, true);
        func21.params.addParam("suffix", "输出后缀", 3, true);
        Function func22 = this.functions.addFunc("DATEVALUE", "日期转换", "将日期值从字符串转化成日期类型", 6);
        func22.params.addParam("text", "字符值", 3);
        func22.params.addParam("format", "日期格式", 3, true);
        Function func23 = this.functions.addFunc("FORMATDATE", "格式化日期", "将日期值按照格式转成字符串", 3);
        func23.params.addParam("date", "日期值", 6);
        func23.params.addParam("format", "日期格式", 3, true);
        Function func24 = this.functions.addFunc("DATE", "日期", "将指定的年、月、日转化成日期类型", 6);
        func24.params.addParam("year", "年", 1);
        func24.params.addParam("month", "月", 1);
        func24.params.addParam("day", "日", 1);
        Function func25 = this.functions.addFunc("DATEADD", "加日期", "返回调整后的新日期", 6);
        func25.params.addParam("date", "日期", 6);
        func25.params.addParam("year", "年", 1);
        func25.params.addParam("month", "月", 1, true);
        func25.params.addParam("day", "日", 1, true);
        Function func26 = this.functions.addFunc("YEAR", "取年", "返回日期中的年份", 1);
        func26.params.addParam("date", "日期", 6);
        Function func27 = this.functions.addFunc("MONTH", "取月", "返回日期中的月份", 1);
        func27.params.addParam("date", "日期", 6);
        Function func28 = this.functions.addFunc("DAY", "取日", "返回日期中的日子", 1);
        func28.params.addParam("date", "日期", 6);
        this.functions.addFunc("TODAY", "今天", "返回当前日期", 6);
        Function func29 = this.functions.addFunc("ISIDCARD", "是合法身份证", "判断个人身份证是否合法", 5);
        func29.params.addParam("text", "身份证", 3);
        Function func30 = this.functions.addFunc("IDCARD18", "转换成18位身份证", "将15位身份证转换成18位身份证", 3);
        func30.params.addParam("text", "身份证", 3);
        Function func31 = this.functions.addFunc("IDCARDDATE", "取身份证日期", "根据个人身份证返回个人的出生日期", 6);
        func31.params.addParam("text", "身份证", 3);
        Function func32 = this.functions.addFunc("IDC", "校验位", "返回单位法人代码的校验位", 3);
        func32.params.addParam("text", "单位法人代码前8位", 3);
        Function func33 = this.functions.addFunc("ISNULL", "是空值", "判断数据是否是空值", 5);
        func33.params.addParam("data", "数据", 0);
        Function func34 = this.functions.addFunc("EXISTCHINESE", "有中文", "判断文本字符串中是否存在中文", 5);
        func34.params.addParam("text", "字符串", 3);
        Function func35 = this.functions.addFunc("INLIST", "在列表中", "判断文本字符串中是否存在列表中", 5);
        func35.params.addParam("text", "字符串", 3);
        func35.params.addParam("comparetext", "比较字符串或字典标识", 3);
        func35.isInfiniteParam = true;
        Function func36 = this.functions.addFunc("DICTVALUE", "取字典值", "依据编码从字典中取得含义值", 3);
        func36.params.addParam("code", "编码", 3);
        func36.params.addParam("dict", "字典标识", 3, false, true);
        func36.params.addParam("mean", "含义列", 3, true, true);
        Function func37 = this.functions.addFunc("GETMEANING", "取字典值", "依据编码从字典中取得含义值", 3);
        func37.params.addParam("code", "编码", 3);
        func37.params.addParam("dict", "字典标识", 3, false, true);
        func37.params.addParam("mean", "含义列", 3, true, true);
        Function func38 = this.functions.addFunc("STATE", "单位状态", "返回单位状态", 1);
        func38.params.addParam("solution", "业务方案标识", 3, true);
        func38.params.addParam("report", "报表标识", 3, true);
        Function func39 = this.functions.addFunc("FLOATSTAT", "浮动行统计", "返回浮动行统计值", 2);
        func39.params.addParam("expression", "浮动行取值表达式", 3);
        func39.params.addParam("condition", "浮动行条件", 3, true);
        func39.params.addParam("statmode", "统计模式", 3, true, true);
        Function func40 = this.functions.addFunc("FLOATCOPY", "浮动行Copy", "执行浮动行Copy功能", 1);
        func40.params.addParam("sourceRelaExp", "源浮动行关联表达式", 3);
        func40.params.addParam("destRelaExp", "目标浮动行关联表达式", 3);
        func40.params.addParam("sourceFilter", "源浮动行过滤条件", 3);
        func40.params.addParam("calcExps", "浮动行间赋值表达式", 3);
        func40.params.addParam("isClearData", "是否清除目标浮动行数据", 5, true);
        func40.params.addParam("isSumCopy", "是否将浮动编码一样浮动行合计复制", 5, true);
        this.functions.addFunc("NULLBLOB", "空二进制", "返回空二进制值", 8);
        Function func41 = this.functions.addFunc("SUM", "汇总统计", "返回汇总值", 2);
        func41.params.addParam("expression", "取值表达式", 3);
        Function func42 = this.functions.addFunc("MAX", "最大值统计", "返回最大值", 2);
        func42.params.addParam("expression", "取值表达式", 3);
        Function func43 = this.functions.addFunc("MIN", "最小值统计", "返回最小值", 2);
        func43.params.addParam("expression", "取值表达式", 3);
        Function func44 = this.functions.addFunc("AVG", "平均值统计", "返回平均值", 2);
        func44.params.addParam("expression", "取值表达式", 3);
        Function func45 = this.functions.addFunc("COUNT", "计数值统计", "返回计数值", 2);
        func45.params.addParam("expression", "数值表达式", 3);
        Function func46 = this.functions.addFunc("CHINESESTR", "中文数值", "将数值转换成中文文本", 3);
        func46.params.addParam("value", "数值", 1);
        func46.params.addParam("capital", "是否大写", 5, true);
        Function func47 = this.functions.addFunc("TokenOf", "提取文本单词", "返回单词内容", 3);
        func47.params.addParam("text", "文本内容", 3);
        func47.params.addParam("index", "单词索引", 1);
        func47.params.addParam("delim", "单词分隔符", 3, true);
        Function func48 = this.functions.addFunc("ChineseDigitUnit", "计算中文数值单位", "返回数值表示的中文单位值", 3);
        func48.params.addParam("unitvalue", "单位数值", 2);
        Function func49 = this.functions.addFunc("MakeLink", "生成超级链接", "生成超级链接存储编码字符串", 3);
        func49.params.addParam("url", "链接地址", 3);
        func49.params.addParam("text", "显示文本", 3, true);
        func49.params.addParam("target", "目标窗口", 3, true);
        Function func50 = this.functions.addFunc("Trim", "去除字符串头尾空格", "去除字符串头尾的空格", 3);
        func50.params.addParam("text", "字符串值", 3);
        Function func51 = this.functions.addFunc("FormatNum", "格式化数值", "将数值格式化为字符串", 3);
        func51.params.addParam("value", "数值", 2);
        func51.params.addParam("decimal", "小数位", 1, true);
        func51.params.addParam("thousand", "是否需要千分位", 5, true);
        func51.params.addParam("minIntLen", "最小整数位数，不足时左侧补0，默认不限制", 1, true);
    }

    @Override // com.jiuqi.syntax.CustomFunctionListener, com.jiuqi.syntax.FunctionListener
    public int callFunction(String funcName, CommonDatas paramValues, CommonData resultData, boolean isCheckMode) {
        int intSize;
        int decSize;
        StringTokenEnumeration stringTokenEnumeration;
        if (funcName.equalsIgnoreCase("ISIDCARD")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 5;
            String str = paramValues.getItem(0).cdString;
            resultData.isNull = str == null;
            resultData.cdBool = IDCard.isIDCard(str);
            return 0;
        }
        if (funcName.equalsIgnoreCase("IDCARD18")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            String str2 = paramValues.getItem(0).cdString;
            resultData.isNull = str2 == null;
            resultData.cdString = IDCard.IDCard18(str2);
            return 0;
        }
        if (funcName.equalsIgnoreCase("IDCARDDATE")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 6;
            resultData.cdDate = IDCard.getIDCardDate(paramValues.getItem(0).cdString);
            resultData.isNull = resultData.cdDate == null;
            return 0;
        }
        if (funcName.equalsIgnoreCase("UPPERCASE")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            String str3 = paramValues.getItem(0).cdString;
            resultData.isNull = str3 == null;
            resultData.cdString = str3 == null ? null : str3.toUpperCase();
            return 0;
        }
        if (funcName.equalsIgnoreCase("LOWERCASE")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            String str4 = paramValues.getItem(0).cdString;
            resultData.isNull = str4 == null;
            resultData.cdString = str4 == null ? null : str4.toLowerCase();
            return 0;
        }
        if (funcName.equalsIgnoreCase("MONEYSTR")) {
            if (paramValues.size() != 3) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            resultData.isNull = false;
            ChineseCurrencyFormat f = new ChineseCurrencyFormat(paramValues.getItem(1).cdString, paramValues.getItem(2).cdString);
            resultData.cdString = f.format(paramValues.getItem(0).getIntRealValue());
            return 0;
        }
        if (funcName.equalsIgnoreCase("CHINESESTR")) {
            if (paramValues.size() != 2) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            resultData.isNull = false;
            ChineseNumberFormat f2 = new ChineseNumberFormat(paramValues.getItem(1).isNull ? false : paramValues.getItem(1).cdBool);
            resultData.cdString = f2.format((long) paramValues.getItem(0).getIntRealValue());
            return 0;
        }
        if (funcName.equalsIgnoreCase("TokenOf")) {
            if (paramValues.size() != 3) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            resultData.isNull = true;
            String delim = paramValues.getItem(2).cdString;
            if (delim == null || delim.length() == 0) {
                stringTokenEnumeration = new StringTokenEnumeration(paramValues.getItem(0).cdString);
            } else {
                stringTokenEnumeration = new StringTokenEnumeration(paramValues.getItem(0).cdString, delim);
            }
            int count = 0;
            int index = (int) paramValues.getItem(1).getIntRealValue();
            while (stringTokenEnumeration.hasMoreElements()) {
                Object ret = stringTokenEnumeration.nextElement();
                if (count == index) {
                    resultData.isNull = false;
                    resultData.cdString = (String) ret;
                    return 0;
                }
                count++;
            }
            return 0;
        }
        if (funcName.equalsIgnoreCase("ChineseDigitUnit")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            String unitExpr = paramValues.getItem(0).isNull ? null : ChineseNumberFormat.toChineseDigitUnit(paramValues.getItem(0).getIntRealValue());
            if (unitExpr == null) {
                resultData.isNull = true;
                return 0;
            }
            resultData.isNull = false;
            resultData.cdString = unitExpr;
            return 0;
        }
        if (funcName.equalsIgnoreCase("Trim")) {
            if (paramValues.size() != 1) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            String text = paramValues.getItem(0).isNull ? null : paramValues.getItem(0).cdString;
            if (text == null) {
                resultData.isNull = true;
                return 0;
            }
            resultData.isNull = false;
            resultData.cdString = text.trim();
            return 0;
        }
        if (funcName.equalsIgnoreCase("FormatNum")) {
            if (paramValues.size() != 4) {
                return SyntaxParser.SY_FUNC_BAD_PARAM;
            }
            resultData.type = 3;
            if (paramValues.getItem(0).isNull) {
                resultData.isNull = true;
                return 0;
            }
            NumberFormat numFmt = NumberFormat.getInstance();
            if (!paramValues.getItem(1).isNull && (decSize = (int) paramValues.getItem(1).getIntRealValue()) >= 0) {
                numFmt.setMaximumFractionDigits(decSize);
                numFmt.setMinimumFractionDigits(decSize);
            }
            numFmt.setGroupingUsed(paramValues.getItem(2).isNull ? true : paramValues.getItem(2).cdBool);
            if (!paramValues.getItem(3).isNull && (intSize = (int) paramValues.getItem(3).getIntRealValue()) > 0) {
                numFmt.setMinimumIntegerDigits(intSize);
            }
            resultData.cdString = numFmt.format(paramValues.getItem(0).getIntRealValue());
            resultData.isNull = false;
            return 0;
        }
        return SyntaxParser.SY_FUNC_NO_EXIST;
    }
}
